import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Snake here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Snake extends Animal
{
    private Counter counter;

    public Snake(Counter resetPoints)
    {
        counter = resetPoints;
    }

    /**
     * Act - do whatever the Snake wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        move(4);
        randomTurn();
        turnAtEdge();
        tryToEatTurtle();
    }    

    /**
     * Randomly turn a small # of degrees left or right
     */
    public void randomTurn()
    {
        if (Greenfoot.getRandomNumber(100) < 10)
        {
            turn(Greenfoot.getRandomNumber(40)-20);
        }
    }

    /**
     * Turn when snake reaches edge of world
     */
    public void turnAtEdge()
    {
        if (atWorldEdge())
        {
            turn(3);
        }  
    }

    /**
     * Try to eat turtle if present
     */
    void tryToEatTurtle()
    {
        if (canSee(Turtle.class))
        {
            eat(Turtle.class);
            counter.setValue(0);
        }

        if (canSee(otherTurtle.class))
        {
            eat(otherTurtle.class);
            counter.setValue(0);
            createNewOtherTurtle();
        }
    }
    
     /**
      * Create a new otherTurtle when one gets eaten. Its name is Bob.
      */
    private void createNewOtherTurtle()
    {
        otherTurtle Bob;
        Bob = new otherTurtle(counter);
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = (Greenfoot.getRandomNumber(worldWidth));
        int y = (Greenfoot.getRandomNumber(worldHeight));
        
        world.addObject(Bob, x, y);
    }
    
}
