import greenfoot.*; 

public class Turtle extends Animal
{
    private int points;
    
    public void act()
    {
    move(4);
    checkKeys();
    tryToEat();    
    }
    
    /**
     * Turn left or right depending on arrow keys pressed.
     */
    public void checkKeys()
    {
        if (Greenfoot.isKeyDown("left"))
        {
            turn(-5);
        }
        
        if (Greenfoot.isKeyDown("right"))
        {
            turn(5);
        }
    }  
    
    
    /**
     * Try to eat lettuce or bugs if present
     */
    void tryToEat()
    {
    if (canSee(Lettuce.class))
    {
        eat(Lettuce.class);
        points++;
    }
    
    if (canSee(Bug.class))
    {
        eat(Bug.class);
        points = points+5;
        createNewBug();
    }
    
    if (points >= 15)
    {
        gameOver();
    }
    }
    
    private void createNewBug()
    {
        Bug newBug;
        newBug = new Bug();
        
        World world;
        world = getWorld();
        
        int worldWidth = world.getWidth();
        int worldHeight = world.getHeight();
        
        int x = Greenfoot.getRandomNumber(worldWidth);
        int y = Greenfoot.getRandomNumber(worldHeight);
        
        world.addObject(newBug, x, y);
    }
    
    public void gameOver()
    {
        Greenfoot.stop();
    }
    
}
